import microbit

Forward = 0
Backward = 1

class MotorDriver():
    def __init__(self):
        self.PWMA = microbit.pin8
        self.AIN1 = microbit.pin13
        self.AIN2 = microbit.pin12
        self.PWMB = microbit.pin16
        self.BIN1 = microbit.pin14
        self.BIN2 = microbit.pin15
        self.S0 = microbit.pin0
        self.S1 = microbit.pin1
        self.S2 = microbit.pin2

    def MotorRun(self, M1dir, M1speed, M2dir, M2speed):
        microbit.pin16.write_analog(int(M2speed))
        microbit.pin8.write_analog(int(M1speed))

        if(M1dir == Forward):
            self.AIN1.write_digital(0)
            self.AIN2.write_digital(1)
        else:
            self.AIN1.write_digital(1)
            self.AIN2.write_digital(0)
        if(M2dir == Forward):
            self.BIN1.write_digital(0)
            self.BIN2.write_digital(1)
        else:
            self.BIN1.write_digital(1)
            self.BIN2.write_digital(0)

    def ServoTurn(self, servo, angle):
        if(angle > 180):
            return
        # temp = angle/2 + 25
        pwm = (angle-90) * 20 / 3 + 1500
        D = pwm / 20000
        if(servo == 0):
            self.S0.write_analog(1023*D)
        elif(servo == 1):
            self.S1.write_analog(1023*D)
        else:
            self.S2.write_analog(1023*D)

m = MotorDriver()
m.MotorRun(Forward, 500, Backward, 500)# left dir, left speed, right dir, right speed
# control 2 motor

m.ServoTurn(0, 50)
m.ServoTurn(1, 150)